#!/usr/local/bin/python

import urllib3
import json
import sys
import os

api_token = "00hbmBCuApngAiwJjYLri_VZ8J6SjNexT_a4ky_qKM"
stub_url = "https://dev-141432.okta.com"
user = ""
user_pass = ""
user_token = ""
require_pass = 0

# we should only have one argument, the credential temp file
if len(sys.argv) > 2:
    sys.stderr.write("Only one argument expected - credential file.")
    exit(1)

# try to read the credential file, should only have two lines

cred_file = open(sys.argv[1], 'r')
creds = cred_file.readlines()
print(creds)
user = creds[0].strip()
user_secrets = creds[1].strip()

def okta_req (url, method = "GET", data = ""):
    http = urllib3.PoolManager()
    if method == "GET":
        req = http.request(
            method, 
            url,
            headers={
                'Accept': 'application/json',
                'Content-Type': 'application/json',
                'Authorization': "SSWS {}".format(api_token)
            })
    else:
        req = http.request(
            method, 
            url,
            headers={
                'Accept': 'application/json',
                'Content-Type': 'application/json',
                'Authorization': "SSWS {}".format(api_token)
            },
            body = json.dumps(data).encode('utf-8'))

    return req.data

def pass_req (user, user_pass):
    if require_pass:
        # this is where you would verify the password works
        return 0
    else:
        return 1


# try to split the password on : character
# note: there are better, more robust ways of doing this, but this was simple 
#       for demonstration purposes
sec_list = user_secrets.split(":", 1)
if len(sec_list) > 1:
    user_pass = sec_list[0]
    user_token = sec_list[1]
else:
    user_token = sec_list[0]

# if there is a password, test it (example always returns true)
if require_pass and not pass_req(user, user_pass):
    print("pass failed")
    os._exit(1)


# now verify the credentials with Okta
user_url = stub_url + "/api/v1/users/{}".format(user)
user_record = json.loads(okta_req(user_url))

# we have the user, now submit their currently entered code
factor_url = stub_url + "/api/v1/users/" + user_record["id"] + "/factors"
user_factors = json.loads(okta_req(factor_url))


for f in user_factors:
    if f["factorType"] == "token:software:totp" and f["status"] == "ACTIVE":
        verify_url = f["_links"]["verify"]["href"]
#        print(verify_url)
    else:
        os._exit(1)

if verify_url:
    method = "POST"
    data = {"passCode":user_token}
    #data = '{"passCode": "' + user_token + '"}'
    okta_resp = json.loads(okta_req(verify_url, method, data))

    try:
        if okta_resp["factorResult"] == "SUCCESS":
            os._exit(0)
    except:
        sys.stderr.write(okta_resp["errorSummary"])


# if we get here, it was a failed auth, so exit as failure
os._exit(1)
